#lang racket/base
(require "global.rkt")

(provide sign
         extract
         collapse)

;; Composing and decomposing numbers from/into signs and (vector digit)

;; sign : num -> { +1 -1 }
(define (sign num)
  (if (>= num 0) 1 -1))

;; extract : num num[>=0] num[>=0] -> number
(define (extract n pos cnt)
  (remainder
    (quotient (abs n) (expt 10 pos))
    (expt 10 cnt)))

;; collapse : { +1 -1 } (vector digit) -> num
(define (collapse sign digits)
  (define (C cnt index sum)
    (cond
     [(zero? cnt) sum]
     [else (C (sub1 cnt) (sub1 index) (+ (* sum 10) (vector-ref digits index)))]))
  (* sign (C IMMEDIATE-DIGITS (sub1 DIGITS) 0)))

