#lang racket/base
(require "global.rkt")

(provide reg-array
         get-reg
         set-reg!)

;; reg-array : (vector value), initialized to 0
(define reg-array (make-vector REGISTERS 0))

;; get-reg : number[register] -> value
(define (get-reg reg)
  (if (register? reg)
      (vector-ref reg-array reg)
      (error 'get-reg "invalid reg number: ~s" reg)))

;; set-reg! : number[register-index] number[value] -> void
(define (set-reg! reg val)
  (if (and (register? reg) (value? val))
      (vector-set! reg-array reg val)
      (error 'set-reg! "invalid reg number: ~s" reg)))
